example_project/articles/urls.py
from django.urls import path
from . import views


app_name = 'articles'
urlpatterns = [
    path('', views.ArticleListView.as_view(),
        name="list"),
    path('~create', views.ArticleCreateView.as_view(),
        name="create"),
    path('<slug:slug>', views.ArticleDetailView.as_view(),
        name="details"),
    path('<slug:slug>/~update', views.ArticleUpdateView.as_view(),
        name="update"),
    path('<slug:slug>/~delete', views.ArticleDeleteView.as_view(),
        name="delete"),
]

example_project/urls.py
from guardian.compat import include,  handler404, handler500
from django.conf import settings
from django.urls import path
from django.contrib import admin
from django.contrib.auth.views import LogoutView

__all__ = ['handler404', 'handler500']

admin.autodiscover()

urlpatterns = [
    path('admin/', admin.site.urls),
    path('logout/', LogoutView.as_view(next_page='/'), name='logout'),
    path('article/', include('articles.urls', namespace='articles')),
    path('', include('posts.urls')),
]

if 'grappelli' in settings.INSTALLED_APPS:
    urlpatterns += [path('grappelli/', include('grappelli.urls')), ]

if 'rosetta' in settings.INSTALLED_APPS:
    urlpatterns += [path('rosetta/', include('rosetta.urls')), ]

example_project/articles/models.py
from django.db import models
from django.urls import reverse


from guardian.models import GroupObjectPermissionBase, UserObjectPermissionBase


class Article(models.Model):
    title = models.CharField('title', max_length=64)
    slug = models.SlugField(max_length=64)
    content = models.TextField('content')
    created_at = models.DateTimeField(auto_now_add=True, db_index=True)

    class Meta:
        default_permissions = ('add', 'change', 'delete')
        permissions = (
            ('view_article', 'Can view article'),
        )
        get_latest_by = 'created_at'

    def __str__(self):
        return self.title

    def get_absolute_url(self):
        return reverse('articles:details', kwargs={'slug': self.slug})


class ArticleUserObjectPermission(UserObjectPermissionBase):
    content_object = models.ForeignKey(Article, on_delete=models.CASCADE)


class ArticleGroupObjectPermission(GroupObjectPermissionBase):
    content_object = models.ForeignKey(Article, on_delete=models.CASCADE)


from guardian.models import UserObjectPermissionAbstract, GroupObjectPermissionAbstract

class BigUserObjectPermission(UserObjectPermissionAbstract):
    id = models.BigAutoField(editable=False, unique=True, primary_key=True)
    class Meta(UserObjectPermissionAbstract.Meta):
        abstract = False
        indexes = [
            *UserObjectPermissionAbstract.Meta.indexes,
            models.Index(fields=['content_type', 'object_pk', 'user']),
        ]


class BigGroupObjectPermission(GroupObjectPermissionAbstract):
    id = models.BigAutoField(editable=False, unique=True, primary_key=True)
    class Meta(GroupObjectPermissionAbstract.Meta):
        abstract = False
        indexes = [
            *GroupObjectPermissionAbstract.Meta.indexes,
            models.Index(fields=['content_type', 'object_pk', 'group']),
        ]

example_project/articles/views.py
from django.urls import reverse_lazy
from django.views.generic import (CreateView, DeleteView, DetailView, ListView,
                                  UpdateView)
from guardian.mixins import PermissionRequiredMixin, PermissionListMixin
from guardian.shortcuts import assign_perm
from articles.models import Article


class ArticleListView(PermissionListMixin, ListView):
    model = Article
    permission_required = ['view_article', ]


class ArticleDetailView(PermissionRequiredMixin, DetailView):
    model = Article
    permission_required = ['view_article']


class ArticleCreateView(PermissionRequiredMixin, CreateView):
    model = Article
    permission_object = None
    permission_required = ['articles.add_article']
    fields = ['title', 'slug', 'content']

    def form_valid(self, *args, **kwargs):
        resp = super().form_valid(*args, **kwargs)
        assign_perm('view_article', self.request.user, self.object)
        assign_perm('change_article', self.request.user, self.object)
        assign_perm('delete_article', self.request.user, self.object)
        return resp


class ArticleUpdateView(PermissionRequiredMixin, UpdateView):
    model = Article
    permission_required = ['view_article', 'change_article']
    fields = ['title', 'slug', 'content']


class ArticleDeleteView(PermissionRequiredMixin, DeleteView):
    model = Article
    success_url = reverse_lazy('articles:list')
    permission_required = ['view_article', 'delete_article']

example_project/articles/templates/articles/article_confirm_delete.html
{% extends "base.html" %}

{% load guardian_tags %}


{% block content %}
<p>Are you sure do you want to delete "<a href="{{object.get_absolute_url}}">{{object}}</a>"?</p>
<form method="POST">
    {% csrf_token %}
    <input type="submit" class="btn btn-primary" value="Delete">
</form>
{% endblock %}

example_project/articles/templates/articles/article_detail.html
{% extends "base.html" %}

{% load guardian_tags %}


{% block content %}
{% get_obj_perms request.user for object as 'object_perms' %}
<div class="row">
    <div class="span3">
        <a href="{% url "articles:list" %}">Back to article list</a>
    </div>


    <div class="span9">
    {% if "change_article" in object_perms %}
    <a href="{% url 'articles:update' slug=object.slug%}" class="btn btn-primary">Update</a>
    {% endif %}
    {% if "delete_article" in object_perms %}
    <a href="{% url 'articles:delete' slug=object.slug%}" class="btn btn-primary">Delete</a>
    {% endif %}
        <h1 name="{{ object.id }}">{{ object.title }}</h1>
        <h5>at {{ object.created_at }}</h5>
        <hr/>
        {{ object.content|safe }}
    </div>
</div>
{% endblock %}

example_project/articles/templates/articles/article_form.html
{% extends "base.html" %}

{% load guardian_tags %}

{% block content %}
<div class="row">
    <div class="span12">
        <h1>{% if object %}
            <a href="{{ object.get_absolute_url }}" name="{{ object.id }}">Back to "{{ object.title }}"</a>
        {% else %}
            <a href="{% url "articles:list" %}">Back to article list</a>
        {% endif %}</h1>
        <form method="post">{% csrf_token %} {{ form.as_p }}
            <input type="submit" value="Save" class="btn btn-primary" />
        </form>
    </div>
</div>
{% endblock %}

example_project/articles/templates/articles/article_list.html
{% extends "base.html" %}

{% block content %}
<div class="row">

    <div class="span12">
        <div class="hero-unit">
            <h1>Articles</h1>
            <a href="{% url "articles:create" %}" class="btn btn-primary">Add article</a>
        </div>
    </div>
{% for object in object_list %}
    <div class="span3">
    </div>
    <div class="span9">
        <a href="{{object.get_absolute_url}}" name="{{ post.id }}"><h1>{{ object.title }}</h1></a>
        <h5>at {{ object.created_at }}</h5>
        <hr/>
        {{ object.content|safe }}
    </div>
{% endfor %}
</div>


{% endblock %}